Name:    kcachegrind
Summary: GUI to profilers such as Valgrind
Version: 23.08.4
Release:    1%{?dist}

License: GPLv2 and GFDL
URL:     https://invent.kde.org/sdk/%{name}

%global revision %(echo %{version} | cut -d. -f3)
%if %{revision} >= 50
%global stable unstable
%else
%global stable stable
%endif
Source0: http://download.kde.org/%{stable}/release-service/%{version}/src/%{name}-%{version}.tar.xz


BuildRequires: desktop-file-utils
BuildRequires: perl-generators
BuildRequires: python3

BuildRequires: extra-cmake-modules
BuildRequires: kf5-rpm-macros
BuildRequires: cmake(KF5Archive)
BuildRequires: cmake(KF5CoreAddons)
BuildRequires: cmake(KF5DBusAddons)
BuildRequires: cmake(KF5DocTools)
BuildRequires: cmake(KF5WidgetsAddons)
BuildRequires: cmake(KF5XmlGui)
BuildRequires: cmake(KF5I18n)
BuildRequires: cmake(KF5Config)
BuildRequires: cmake(KF5KIO)

BuildRequires: cmake(Qt5DBus)
BuildRequires: cmake(Qt5Gui)
BuildRequires: cmake(Qt5LinguistTools)
BuildRequires: cmake(Qt5Widgets)

Conflicts: kde-l10n < 17.03

Conflicts:      kdesdk-common < 4.10.80
Provides:       kdesdk-kcachegrind = %{version}-%{release}

%description
Browser for data produced by profiling tools (e.g. cachegrind)

%package converters
Summary: Converters for kcachegrind
Requires: %{name} = %{version}-%{release}
%description converters
%{summary}.

%package -n qcachegrind
Summary: QT GUI to profilers such as Valgrind

%description -n qcachegrind
QT-based browser for data produced by profiling tools (e.g. cachegrind).


%prep
%autosetup -p1

sed -i.env -e "s|^#!/usr/bin/env python$|#!%{__python3}|g" converters/hotshot2calltree.in
sed -i.env -e "s|^#!/usr/bin/env php$|#!%{_bindir}/php|g"  converters/pprof2calltree


%build
%cmake_kf5

%cmake_build


%install
%cmake_install

install -p -m 755 %{__cmake_builddir}/bin/qcachegrind %{buildroot}%{_bindir}/
install -p -m 755 %{__cmake_builddir}/bin/cgview %{buildroot}%{_bindir}/
install -p -m 644 qcachegrind/qcachegrind.desktop %{buildroot}%{_datadir}/applications/


%check
desktop-file-validate %{buildroot}%{_kf5_datadir}/applications/org.kde.%{name}.desktop
desktop-file-validate %{buildroot}%{_datadir}/applications/qcachegrind.desktop

%find_lang %{name} --all-name --with-html
%find_lang_kf5 kcachegrind_qt
cat kcachegrind_qt.lang >> kcachegrind.lang


%files -f %{name}.lang
%doc README
%license LICENSES/*
%{_kf5_bindir}/kcachegrind
%{_kf5_datadir}/kcachegrind/
%{_kf5_datadir}/applications/org.kde.kcachegrind.desktop
%{_kf5_metainfodir}/org.kde.kcachegrind.appdata.xml
%{_kf5_datadir}/icons/hicolor/*/apps/kcachegrind.*

%files converters
%doc converters/README
%{_kf5_bindir}/dprof2calltree
%{_kf5_bindir}/memprof2calltree
%{_kf5_bindir}/op2calltree
%{_kf5_bindir}/hotshot2calltree
%{_kf5_bindir}/pprof2calltree

%files -n qcachegrind
%doc README
%license LICENSES/*
%{_bindir}/qcachegrind
%{_bindir}/cgview
%{_datadir}/applications/qcachegrind.desktop
%{_datadir}/icons/hicolor/*/apps/kcachegrind.*


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 23.08.4-1
- initial build
